<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

include_spip('inc/autoriser');

function ciwidget_types_widget(){

    // id doit contenir uniquement des lettres (pas de chiffres, ni de tiret, ni d'autres caracteres speciaux)
    $types_widget = array();
    
    // Audio
    $types_widget[100] = array(
            'id' => 'audio',
            'titre' => _T('ciwidget:widget_audio_titre'),
            'descriptif' => _T('ciwidget:widget_audio_descriptif'),
            'vignette' => 'ciwidget_audio.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
            'css' => 'oui',
            'sans_alignement'=>'oui'
    );

    // GIS
    if (defined('_DIR_PLUGIN_GIS')){
        $types_widget[200] = array(
                'id' => 'gis',
                'titre' => _T('ciwidget:widget_gis_titre'),
                'descriptif' => _T('ciwidget:widget_gis_descriptif'),
                'vignette' => 'ciwidget_gis.png',
                'objets' => 'article,rubrique',
                'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
                'sans_alignement'=>'oui'
        );
    }
    
    // Chiffre
    $types_widget[250] = array(
            'id' => 'chiffre',
            'titre' => _T('ciwidget:widget_chiffre_titre'),
            'descriptif' => _T('ciwidget:widget_chiffre_descriptif'),
            'vignette' => 'ciwidget_chiffre.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
            'css' => 'oui',
            'elements' => 'chiffre,unite,descriptif',
            'valeurs_par_defaut' => array(
                'chiffre_background-color'=>'gris2',
                'chiffre_font-family'=>'"Arial Narrow",Arial',
                'chiffre_font-size'=>'5rem',
                'chiffre_line-height'=>'5rem',
                'chiffre_font-weight'=>'700',
                'chiffre_height'=>'14rem',
                'unite_font-size'=>'1rem',
                'unite_line-height'=>'1rem',
                'unite_font-weight'=>'',
                'descriptif_background-color'=>'gris6',
                'descriptif_font-size'=>'0.875rem',
                'descriptif_line-height'=>'1.2rem',
                'descriptif_font-weight'=>'',
                'descriptif_text-align'=>'left'
                )
    );

    // Citation
    $types_widget[280] = array(
            'id' => 'citation',
            'titre' => _T('ciwidget:widget_citation_titre'),
            'descriptif' => _T('ciwidget:widget_citation_descriptif'),
            'vignette' => 'ciwidget_citation.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
            'css' => 'oui',
            'sans_alignement'=>'oui',
            'elements' => 'bloc,figure,texte,quote,auteur,source,ouvrage,image,icone1',
            'valeurs_par_defaut' => array(
                'ajoutquote'=>'quote1',
                'affichericone'=>'non',
                'espacevidesansvignette'=>'non',
                
                'bloc_background-color'=>'transparent',
                'bloc_border-style'=>'solid',
                'bloc_border-color'=>'gris4',
                'bloc_border-width'=>'0 0 0 5px',
                'bloc_border-radius'=>'0px',
                'bloc_padding'=>'1rem 0 1rem 2rem',
                'bloc_max-width'=>'',
                'bloc_text-align'=>'left',

                'figure_border-color'=>'transparent',
                'figure_border-left-width'=>'0px',

                'icone1_mask-image'=>'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24"><path fill="none" d="M0 0H24V24H0z"/><path d="M21 3c.552 0 1 .448 1 1v14c0 .552-.448 1-1 1H6.455L2 22.5V4c0-.552.448-1 1-1h18zm-1 2H4v13.385L5.763 17H20V5zm-9.485 2.412l.447.688c-1.668.903-1.639 2.352-1.639 2.664.155-.02.318-.024.48-.009.902.084 1.613.825 1.613 1.745 0 .966-.784 1.75-1.75 1.75-.537 0-1.05-.245-1.374-.59-.515-.546-.792-1.16-.792-2.155 0-1.75 1.228-3.318 3.015-4.093zm5 0l.447.688c-1.668.903-1.639 2.352-1.639 2.664.155-.02.318-.024.48-.009.902.084 1.613.825 1.613 1.745 0 .966-.784 1.75-1.75 1.75-.537 0-1.05-.245-1.374-.59-.515-.546-.792-1.16-.792-2.155 0-1.75 1.228-3.318 3.015-4.093z"/></svg>',
                'icone1_icon-size'=>'2rem',
                'icone1_color'=>'gris6',
                'icone1_margin-bottom'=>'0.5rem',
                
                'texte_font-family'=>'',
                'texte_font-size'=>'1.25rem',
                'texte_line-height'=>'2rem',
                'texte_font-weight'=>'700',
                'texte_font-style'=>'normal',
                'texte_margin-bottom'=>'1rem',

                'quote_font-size'=>'',
                'quote_line-height'=>'',
                'quote_font-weight'=>'',
                'quote_padding-right'=>'0.5rem',
                'quote_padding-left'=>'0.5rem',
                
                'image_height'=>'11.5rem',
                'image_width'=>'11.5rem',
                'image_border-radius'=>'50%',
                
                'auteur_font-family'=>'',
                'auteur_font-size'=>'0.875rem',
                'auteur_line-height'=>'1.5rem',
                'auteur_font-weight'=>'700',
                'auteur_margin-bottom'=>'0.25rem',

                'source_font-family'=>'',
                'source_font-size'=>'0.75rem',
                'source_line-height'=>'1.25rem',
                'source_font-weight'=>'',
                'source_margin-bottom'=>'',

                'ouvrage_font-style'=>'italic'
                )
    );

    // Galerie
    $types_widget[300] = array(
            'id' => 'galerie',
            'titre' => _T('ciwidget:widget_galerie_titre'),
            'descriptif' => _T('ciwidget:widget_galerie_descriptif'),
            'vignette' => 'ciwidget_galerie.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
            'css' => 'oui',
            'sans_alignement'=>'oui',
            'elements' => 'galerie,image,fleche,compteur,vignette,point',
            'valeurs_par_defaut' => array(
                'type_galerie_defaut'=>'vignette',
                'imposer_type_galerie'=>'non',
                'afficher_image_en_grand'=>'non',
                'galerie_width'=>'100%',
                'galerie_background-colorhexa'=>'',
                'image_border-radius'=>'0px',
                'fleche_colorhexa'=>'#3A3A3A',
                'fleche_height'=>'2rem',
                'fleche_width'=>'2rem',
                'fleche_opacity'=>'1',
                'compteur_colorhexa'=>'#3A3A3A',
                'compteur_font-size'=>'1.4rem',
                'vignette_width'=>'100px',
                'vignette_opacity'=>'0.6',
                'point_height'=>'0.875rem',
                'point_width'=>'0.875rem',
                'point_margin'=>'0 0.2rem 0 0.2rem ',
                'point_background-colorhexa'=>'#FFFFFF',
                'point_background-colorhexaactive'=>'#3A3A3A',
                'point_border-style'=>'solid',
                'point_border-colorhexa'=>'#494949',
                'point_border-width'=>'2px',
                'point_opacity'=>'1'
                )
    );
    
    // Graphique
    $types_widget[350] = array(
            'id' => 'graphique',
            'titre' => _T('ciwidget:widget_graphique_titre'),
            'descriptif' => _T('ciwidget:widget_graphique_descriptif'),
            'vignette' => 'ciwidget_graphique.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
            'css' => 'oui',
            'non_imposable' => 'oui',
            'valeurs_par_defaut' => array(
                'type'=>'bar',
                'tableau_du_graphique'=>'oui',
                'largeur_defaut'=>'500',
                'largeur_pourcentage'=>'100',
                'aspect_ratio'=>'1.3',
                'imposer_ratio_comme_maximum'=>'non',
                'legend_display'=>'true',
                'legend_position'=>'bottom',
                'legend_align'=>'start',
                'legend_reverse'=>'false',
                'xAxes_gridLines_color'=>'#B2B2B2',
                'xAxes_rotation'=>'false',
                'xAxes_gridLines_display'=>'true',
                'xAxes_labelString'=> _T('ciwidget:xAxes_titre'),
                'xAxes_maxTicksLimit'=>'',
                'xAxes_suggestedMin'=>'',
                'xAxes_suggestedMax'=>'',
                'yAxes_gridLines_color'=>'#B2B2B2',
                'yAxes_gridLines_display'=>'true',
                'yAxes_labelString'=> _T('ciwidget:yAxes_titre'),
                'yAxes_maxTicksLimit'=>'',
                'yAxes_suggestedMin'=>'',
                'yAxes_suggestedMax'=>'',
                'yAxes_unite'=>'',
                'yAxes_stacked'=>'false',
                'axe_suggestedMin'=>'',
                'axe_suggestedMax'=>'',
                'axe_maxTicksLimit'=>'',
                'axe_ticks_display'=>'true',
                'opacite'=>'30',
                'arrondi'=>'100',
                'showline_defaut'=>'oui',
                'lineborderwidth_defaut'=>'1',
                'lineborderwidth'=>'1',
                'lineborderwidth_serie_defaut'=>'100',
                'lineborderdash_serie_defaut'=>'0',
                'lineborderdash_defaut'=>'0',
                'point_style'=>'circle',
                'point_radius'=>'3',
                'radius_serie_defaut'=>'100',
                'couleur_serie1'=>'#0098ED',
                'couleur_serie2'=>'#F28E2B',
                'couleur_serie3'=>'#59A14F',
                'couleur_serie4'=>'#E15759',
                'couleur_serie5'=>'#79706E',
                'couleur_serie6'=>'#B07AA1',
                'couleur_serie7'=>'#A0CBE8',
                'couleur_serie8'=>'#FFBE7D',
                'couleur_serie9'=>'#8CD17D',
                'couleur_serie10'=>'#FF9D9A',
                'couleur_serie11'=>'#BAB0AC',
                'couleur_serie12'=>'#D4A6C8',
                'categoryPercentage'=>'80',
                'barPercentage'=>'10',
                'circumference'=>'2',
                'rotation'=>'0',
                'download_csv'=>'oui',
                'serie_colonne'=>'oui',
                'entete_colonne'=>'oui',
                'entete_ligne'=>'oui',
                'import_auto_active'=>'non',
                'import_auto_url'=>'',
                'import_auto_date_premier'=>'',
                'import_auto_date_dernier'=>'',
                'import_auto_delai'=>'',
                'import_auto_delai_unite'=>'month',
                'moyenne_active'=>'non',
                'moyenne_ordre'=>'3',
                'defaultfontfamily'=>'"Helvetica Neue", Helvetica, Arial, sans-serif',
                'title_fontfamily'=>'Arial, Helvetica, sans-serif',
                'legend_fontfamily'=>'Arial, Helvetica, sans-serif',
                'defautfontweight'=>'normal',
                'title_fontweight'=>'bold',
                'legend_fontweight'=>'bold',
                'defaultfontcolor'=>'#666666',
                'title_fontsize'=>'12',
                'legend_fontsize'=>'12',
                'xaxeslabel_fontsize'=>'12',
                'xaxesticks_fontsize'=>'12',
                'yaxeslabel_fontsize'=>'12',
                'yaxesticks_fontsize'=>'12',
                'tooltips_titlefontsize'=>'12',
                'tooltips_bodyfontsize'=>'12',
                'ci_xaxes_showlastlabel'=>'false',
                'ci_xaxes_lastlabelfontsize'=>'12',
                )
    );

    // Infographie
    $types_widget[400] = array(
            'id' => 'infographie',
            'titre' => _T('ciwidget:widget_infographie_titre'),
            'descriptif' => _T('ciwidget:widget_infographie_descriptif'),
            'vignette' => 'ciwidget_infographie.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
    );

    // Iframe
    $types_widget[410] = array(
            'id' => 'iframe',
            'titre' => _T('ciwidget:widget_iframe_titre'),
            'descriptif' => _T('ciwidget:widget_iframe_descriptif'),
            'vignette' => 'ciwidget_iframe.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
            'valeurs_par_defaut' => array(
                'largeur_defaut'=>'700',
                'hauteur_defaut'=>'768',
                'masquer_bordure'=>'non',
                'limiter_hosts'=>'non',
                'hosts_liste'=>''
                )
    );
    
    // Linkedin
    $types_widget[450] = array(
            'id' => 'linkedin',
            'titre' => _T('ciwidget:widget_linkedin_titre'),
            'descriptif' => _T('ciwidget:widget_linkedin_descriptif'),
            'vignette' => 'ciwidget_linkedin.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'oui',
            'valeurs_par_defaut' => array(
                'largeur_defaut'=>'504'
                )
    );
    
    // Portait
    $types_widget[490] = array(
            'id' => 'portrait',
            'titre' => _T('ciwidget:widget_portrait_titre'),
            'descriptif' => _T('ciwidget:widget_portrait_descriptif'),
            'vignette' => 'ciwidget_portrait.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
            'css' => 'oui',
            'sans_alignement'=>'oui',
            'elements' => 'bloc,contenu,icone1,surtitre,nom,fonction,organisationnom,organisationsiteweb,texte,image,creditphoto',
            'valeurs_par_defaut' => array(
                'affichericone'=>'oui',
                'surtitre_niveau_titre'=>'h4',
                'nom_niveau_titre'=>'h5',
                'utilisersurtitre'=>'non',

                'bloc_background-color'=>'gris1',
                'bloc_border-style'=>'',
                'bloc_border-color'=>'',
                'bloc_border-width'=>'0',
                'bloc_border-radius'=>'0px',
                'bloc_max-width'=>'',
                'bloc_text-align'=>'left',

                'contenu_padding'=>'2rem',

                'icone1_mask-image'=>'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24"><path d="M4 22C4 17.5817 7.58172 14 12 14C16.4183 14 20 17.5817 20 22H4ZM12 13C8.685 13 6 10.315 6 7C6 3.685 8.685 1 12 1C15.315 1 18 3.685 18 7C18 10.315 15.315 13 12 13Z"></path></svg>',
                'icone1_icon-size'=>'2rem',
                'icone1_color'=>'gris6',

                'surtitre_font-family'=>'',
                'surtitre_font-size'=>'2rem',
                'surtitre_line-height'=>'2rem',
                'surtitre_font-weight'=>'bold',
                'surtitre_font-style'=>'',
                'surtitre_padding'=>'0rem',
                'surtitre_margin'=>'0rem',

                'personne_padding'=>'1rem 0 1rem 0',
                
                'nom_font-family'=>'',
                'nom_font-size'=>'1.4rem;',
                'nom_line-height'=>'',
                'nom_font-weight'=>'bold',
                'nom_font-style'=>'',
                'nom_padding'=>'0 0 0.25rem 0',
                'nom_margin'=>'0rem',

                'fonction_font-family'=>'',
                'fonction_font-size'=>'0.8125rem',
                'fonction_line-height'=>'0.8125rem',
                'fonction_font-weight'=>'',
                'fonction_font-style'=>'',
                'fonction_padding'=>'',

                'organisationnom_font-family'=>'',
                'organisationnom_font-size'=>'0.8125rem',
                'organisationnom_line-height'=>'0.8125rem',
                'organisationnom_font-weight'=>'',
                'organisationnom_font-style'=>'',
                'organisationnom_padding'=>'',

                'organisationsiteweb_font-family'=>'',
                'organisationsiteweb_font-size'=>'0.8125rem',
                'organisationsiteweb_line-height'=>'0.8125rem',
                'organisationsiteweb_font-weight'=>'',
                'organisationsiteweb_font-style'=>'',
                'organisationsiteweb_padding'=>'',

                'texte_font-family'=>'',
                'texte_font-size'=>'',
                'texte_line-height'=>'',
                'texte_font-weight'=>'',
                'texte_font-style'=>'',
                'texte_padding'=>'',

                'creditphoto_font-family'=>'',
                'creditphoto_font-size'=>'0.875rem',
                'creditphoto_line-height'=>'',
                'creditphoto_font-weight'=>'',
                'creditphoto_font-style'=>'',
                'creditphoto_padding'=>'0.5rem 0 0.5rem 0',

                'image_padding'=>'4rem 2rem 2rem 2rem',
                'image_max-width'=>'14rem',
                'image_border-radius'=>'',
                )
    );

    // rss
    $types_widget[500] = array(
            'id' => 'rss',
            'titre' => _T('ciwidget:widget_rss_titre'),
            'descriptif' => _T('ciwidget:widget_rss_descriptif'),
            'vignette' => 'ciwidget_rss.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'css' => 'oui',
            'formes' => array('forme1','forme2'),
            'elements' => 'bloc,titre,separateur,titreitem,descriptif,source',
            'valeurs_par_defaut' => array(
                'nb_article_defaut'=>10,
                'titre_niveau_titre'=>'h5',
                'titreitem_niveau_titre'=>'h6',
                'affiche_descriptif_defaut'=>'oui',
                'affiche_date_article_defaut'=>'oui',
                'forme'=>'forme1',
                'bloc_background-color'=>'transparent',
                'bloc_border-style'=>'solid',
                'bloc_border-color'=>'gris4',
                'bloc_border-width'=>'0.125rem',
                'bloc_padding'=>'2rem',
                'bloc_text-align'=>'left',
                'titre_font-family'=>'',
                'titre_font-size'=>'1rem',
                'titre_line-height'=>'1rem',
                'titre_font-weight'=>'300',
                'titre_margin-bottom'=>'1.25rem',
                'separateur_background-color'=>'gris6',
                'separateur_width'=>'3rem',
                'separateur_height'=>'0.3rem',
                'separateur_margin-top'=>'0.5rem',
                'titreitem_font-size'=>'0.9rem',
                'titreitem_font-weight'=>'normal',
                'titreitem_line-height'=>'1rem',
                'titreitem_margin-bottom'=>'0.5rem',
                'titreitem_text-align'=>'left',
                'descriptif_font-size'=>'',
                'descriptif_line-height'=>'1rem',
                'descriptif_margin-bottom'=>'1rem',
                'source_font-size'=>'0.7rem',
                'source_line-height'=>'1rem',
                'source_font-weight'=>'normal',
            )
    );

    // sitereference
    $types_widget[550] = array(
            'id' => 'sitereference',
            'titre' => _T('ciwidget:widget_sitereference_titre'),
            'descriptif' => _T('ciwidget:widget_sitereference_descriptif'),
            'vignette' => 'ciwidget_sitereference.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'css' => 'oui',
            'elements' => 'bloc,titre,separateur,descriptif,lien',
            'valeurs_par_defaut' => array(
                'titre_lien'=>'titre_lien1',
                'imposer_alignement_widget'=>'non',
                'bloc_background-color'=>'transparent',
                'bloc_border-style'=>'solid',
                'bloc_border-color'=>'gris4',
                'bloc_border-width'=>'0.125rem',
                'bloc_max-width'=>'',
                'bloc_padding'=>'2rem',
                'bloc_text-align'=>'left',
                'titre_niveau_titre'=>'h5',
                'titre_font-family'=>'',
                'titre_font-size'=>'1.5rem',
                'titre_line-height'=>'1.75rem',
                'titre_font-weight'=>'300',
                'titre_margin-bottom'=>'0.625rem',
                'separateur_background-color'=>'gris6',
                'separateur_width'=>'3rem',
                'separateur_height'=>'0.3rem',
                'separateur_margin-top'=>'0.5rem',
                'descriptif_font-size'=>'0.9rem',
                'descriptif_line-height'=>'1rem',
                'descriptif_margin-bottom'=>'1.25rem',
                'lien_background-color'=>'gris6',
                'lien_background-colorhover'=>'blanc',
                'lien_border-style'=>'solid',
                'lien_border-color'=>'gris6',
                'lien_border-width'=>'0.062rem',
                'lien_border-radius'=>'3px',
                'lien_color'=>'blanc',
                'lien_font-size'=>'0.9rem',
                'lien_font-weight'=>'normal',
                'lien_padding'=>'0.5rem 0.7rem',
                'lien_text-align'=>'center',
            )
    );

    // Slideshare
    $types_widget[600] = array(
            'id' => 'slideshare',
            'titre' => _T('ciwidget:widget_slideshare_titre'),
            'descriptif' => _T('ciwidget:widget_slideshare_descriptif'),
            'vignette' => 'ciwidget_slideshare.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'oui',
            'valeurs_par_defaut' => array(
                'largeur_defaut'=>'595'
                )
    );

    // Tableau
    $types_widget[650] = array(
            'id' => 'tableau',
            'titre' => _T('ciwidget:widget_tableau_titre'),
            'descriptif' => _T('ciwidget:widget_tableau_descriptif'),
            'vignette' => 'ciwidget_tableau.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'non_imposable' => 'oui',
            'sans_alignement'=>'oui'
    );

    // Tweet
    $types_widget[700] = array(
            'id' => 'tweet',
            'titre' => _T('ciwidget:widget_tweet_titre'),
            'descriptif' => _T('ciwidget:widget_tweet_descriptif'),
            'vignette' => 'ciwidget_tweet.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'oui',
            'valeurs_par_defaut' => array(
                'largeur_defaut'=>'480'
                )
    );

    // Fil Twitter
    $types_widget[710] = array(
            'id' => 'twitter',
            'titre' => _T('ciwidget:widget_twitter_titre'),
            'descriptif' => _T('ciwidget:widget_twitter_descriptif'),
            'vignette' => 'ciwidget_twitter.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'oui',
            'valeurs_par_defaut' => array(
                'largeur_defaut'=>'250',
                'hauteur_defaut'=>'500'
                )
    );

    // Video
    $types_widget[800] = array(
            'id' => 'video',
            'titre' => _T('ciwidget:widget_video_titre'),
            'descriptif' => _T('ciwidget:widget_video_descriptif'),
            'vignette' => 'ciwidget_video.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non'
    );

    // Video distante
    $types_widget[810] = array(
            'id' => 'videodistante',
            'titre' => _T('ciwidget:widget_videodistante_titre'),
            'descriptif' => _T('ciwidget:widget_videodistante_descriptif'),
            'vignette' => 'ciwidget_videodistante.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
    );

    // Dailymotion
    $types_widget[820] = array(
            'id' => 'dailymotion',
            'titre' => _T('ciwidget:widget_dailymotion_titre'),
            'descriptif' => _T('ciwidget:widget_dailymotion_descriptif'),
            'vignette' => 'ciwidget_dailymotion.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'oui',
            'valeurs_par_defaut' => array(
                'playlist_defaut'=>'',
                'largeur_defaut'=>'576',
                'hauteur_defaut'=>'324',
                'api_dailymotion'=>'non'
                )
    );

    // Video terra
    $types_widget[830] = array(
            'id' => 'videoterra',
            'titre' => _T('ciwidget:widget_videoterra_titre'),
            'descriptif' => _T('ciwidget:widget_videoterra_descriptif'),
            'vignette' => 'ciwidget_videoterra.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non',
    );

    // Youtube
    $types_widget[840] = array(
            'id' => 'youtube',
            'titre' => _T('ciwidget:widget_youtube_titre'),
            'descriptif' => _T('ciwidget:widget_youtube_descriptif'),
            'vignette' => 'ciwidget_youtube.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'oui',
            'valeurs_par_defaut' => array(
                'largeur_defaut'=>'640',
                'hauteur_defaut'=>'360'
                )
    );

    // StreamHLS
    $types_widget[850] = array(
            'id' => 'streamhls',
            'titre' => _T('ciwidget:widget_streamhls_titre'),
            'descriptif' => _T('ciwidget:widget_streamhls_descriptif'),
            'vignette' => 'ciwidget_streamhls.png',
            'objets' => 'article,rubrique',
            'autorise' => 'redacteur,admin_restreint,admin_site,webmestre',
            'concerne_rgpd' => 'non'
    );
    
    return $types_widget;
}

function ciwidget_types_widget_objet($objet=''){
    $return = array();
    $objets = array();

    // par exemple pour avoir la liste des widgets qui concernent les articles
    if ($objet){
        $types_widget = ciwidget_types_widget();
        
        foreach ($types_widget AS $cle=>$type_widget) {
            if (isset($type_widget['objets'])){
                $objets = explode(',',$type_widget['objets']);
                if (in_array($objet, $objets)){
                    $return[] = $type_widget;
                }
            }
        }
    }
    
    return $return;
}

function ciwidget_vignette_type_widget($id_type=''){
    $return = '';
    $types_widget = ciwidget_types_widget();
    $titre = '';
    
    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['vignette']) AND isset($type_widget['id']) AND $type_widget['id']==$id_type){
            if (isset($type_widget['titre']) AND $type_widget['titre']){
                $titre = attribut_html($type_widget['titre']);
            } else {
                $titre = $id_type;
            }
            $return = '<img src="'.find_in_path('_vignettes/'.$type_widget['vignette']).'" alt="'.$titre.'">';
        }
    };
    
    return $return;
}

function ciwidget_tableau_id_type_widget(){
    $return = array();
    $types_widget = ciwidget_types_widget();
    
    foreach ($types_widget AS $cle=>$type_widget) {
        if (isset($type_widget['id'])){
            $return[] = $type_widget['id'];
        }
    };
    
    return $return;
}

function ciwidget_verifier_autorise($liste=''){
    $return = false;
    
    if (!$liste){
        $return = true;
    } else {
        // valeurs possibles pour la liste : redacteur,admin_restreint,admin_site,webmestre 
        $tableau = explode(',',$liste);
        $tableau = array_map('trim', $tableau);

        if ($GLOBALS['visiteur_session']['statut']=='1comite'){
            // redacteur
            if (in_array('redacteur',$tableau)){
                $return = true;
            }
            
        } elseif ($GLOBALS['visiteur_session']['statut']=='0minirezo'){
            if ($GLOBALS['visiteur_session']['webmestre']=='oui'){
                // webmestre
                if (in_array('webmestre',$tableau)){
                    $return = true;
                }
                
            } else {
                $auteur_restreint = sql_countsel("spip_auteurs_liens", "objet='rubrique' AND id_auteur=".intval($GLOBALS['visiteur_session']['id_auteur']));
                
                if ($auteur_restreint>0){
                    // admin_restreint
                    if (in_array('admin_restreint',$tableau)){
                        $return = true;
                    }
                } else {
                    // admin_site
                    if (in_array('admin_site',$tableau)){
                        $return = true;
                    }
                }
            }
        }
    }
    
    return $return;
}

?>