<?php
/**
 * Plugin CIWIDGET 
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/widget_commun');

function ciwidget_graphique_importer($id_widget,$tmp=false,$forcer=false,$url_objet=''){
    $return = '';
    $ok = false;
    $id_widget = intval($id_widget);
    $type_widget = 'graphique';
    
    $import_auto_url = ciwidget_parametres_import($id_widget,$type_widget,$tmp,$forcer);
    
    if ($import_auto_url){
        include_spip('inc/distant');
        
        $c = array();
        $contenu_nouveau = array();
        $texte = '';
        $tableau_extensions = array('xlsx','csv');
        
        $extension = ciwidget_extension_tableau_distant($import_auto_url,$tableau_extensions);
        
        $result = recuperer_url($import_auto_url);
        if (isset($result['page'])){
            $texte = $result['page'];
        }
        
        $c['donnees'] = '';
                
        if ($extension=='xlsx'){
            $c['donnees'] = ciwidget_lire_xlsx('',$texte);
            
        } elseif ($extension=='csv'){
            $c['donnees'] = ciwidget_lire_csv('',$texte);
        }

        if ($c['donnees']){
            $contenu_nouveau['import_auto_date_dernier'] = time();
        
            if ($tmp){
                $id_widget_tmp = ciwidget_maj_tmp(0,$id_widget,$c,$contenu_nouveau);
            } else {
                $contenu_actuel = array();
                $row = sql_fetsel("*", "spip_ciwidget", "id_widget=$id_widget");
                if ($row){
                    $contenu_actuel = unserialize($row['contenu']); 
                    $titre = $row['titre'];
                    $objet = $row['objet'];
                    $id_objet = $row['id_objet'];
                }
                $c['contenu'] = serialize(array_merge($contenu_actuel,$contenu_nouveau));
                sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");

                include_spip('inc/ciwidget_graphique');
                ciwidget_enregistrer_csv($id_widget);
                
                // invalider le cache correspondant
                if (!test_espace_prive()){
                    include_spip('inc/ciwidget_invalider');
                    ciwidget_invalider_cache($id_objet,$objet,$url_objet);
                }
                
                // tracer
                if (defined('_DIR_PLUGIN_CITRACE')){
                    if ($citrace = charger_fonction('citrace', 'inc')) {
                        $message = '('.$titre.') dans '.$objet.' '.$id_objet;				
                        $citrace('widget', $id_widget, 'import auto de donnees du widget de type '.$type_widget, $message);
                    }
                }
            }
        }
    }
    
    return $return;
}

function ciwidget_parametres_import($id_widget,$type_widget,$tmp=false,$forcer=false){
    $return = '';
    $ok = false;
    $id_widget = intval($id_widget);
    
    // recuperer les parametres dans la config du widget
    $tableau_param = array(
        'import_auto_active' => '',
        'import_auto_url' => '',
        'import_auto_date_premier' => '', // timestamp
        'import_auto_date_dernier' => '', // timestamp
        'import_auto_delai' => '',
        'import_auto_delai_unite' => '', // en anglais : month,day,hour,minute
    );

    if ($tmp){
        $valeurs = ciwidget_valeurs_tmp(0,$id_widget,$type_widget);
    } else {
        $valeurs = ciwidget_valeurs_lues_en_base($id_widget,$type_widget);
    }

    foreach ($tableau_param AS $cle=>$valeur){
        if (isset($valeurs[$cle])){
            $tableau_param[$cle] = $valeurs[$cle];
        }
    }

    if ($tableau_param['import_auto_url']){
        if ($forcer){
            $ok = true;
            
        } elseif ($tableau_param['import_auto_active']=='oui'  
                    AND $tableau_param['import_auto_date_premier'] 
                    AND $tableau_param['import_auto_delai'] 
                    AND $tableau_param['import_auto_delai_unite'] 
                ){
            
            $timestamp_actuel = time();
            
            if ($timestamp_actuel >= $tableau_param['import_auto_date_premier']){
                if ($tableau_param['import_auto_date_dernier']){
                    if ($timestamp_actuel >= strtotime('+'.$tableau_param['import_auto_delai'].' '.$tableau_param['import_auto_delai_unite'],$tableau_param['import_auto_date_dernier'])){
                        $ok = true;
                    }
                } else {
                    $ok = true;
                }
            }
        }
        
        if ($ok){
            $return = $tableau_param['import_auto_url'];
        }
    }
    
    return $return;
}

function ciwidget_tableau_importer($id_widget,$tmp=false,$forcer=false,$url_objet=''){
    $return = '';
    $ok = false;
    $id_widget = intval($id_widget);
    // difference
    $type_widget = 'tableau';
    
    $import_auto_url = ciwidget_parametres_import($id_widget,$type_widget,$tmp,$forcer);
    
    if ($import_auto_url){
        include_spip('inc/distant');
        
        $c = array();
        $contenu_nouveau = array();
        $texte = '';
        $tableau_extensions = array('xlsx','csv');
        
        $extension = ciwidget_extension_tableau_distant($import_auto_url,$tableau_extensions);
        
        $result = recuperer_url($import_auto_url);
        if (isset($result['page'])){
            $texte = $result['page'];
        }
        
        // difference
        if ($extension=='xlsx'){
            $c['donnees'] = ciwidget_lire_xlsx('',$texte,false);
            
        } elseif ($extension=='csv'){
            $c['donnees'] = ciwidget_lire_csv('',$texte,false);
        }

        if (isset($c['donnees']) AND $c['donnees']){
            $contenu_nouveau['import_auto_date_dernier'] = time();
        
            if ($tmp){
                $id_widget_tmp = ciwidget_maj_tmp(0,$id_widget,$c,$contenu_nouveau);
            } else {
                $contenu_actuel = array();
                $titre = '';
                $descriptif = ''; 
                $entete_colonne = 'non';
                $entete_ligne = 'non';
                
                $row = sql_fetsel("*", "spip_ciwidget", "id_widget=$id_widget");
                if ($row){
                    $titre = $row['titre'];
                    $descriptif = $row['descriptif'];
                    $objet = $row['objet'];
                    $id_objet = $row['id_objet'];
                    $contenu_actuel = unserialize($row['contenu']);
                    if (isset($contenu_actuel['entete_colonne'])){
                        $entete_colonne = $contenu_actuel['entete_colonne'];
                    }
                    if (isset($contenu_actuel['entete_ligne'])){
                        $entete_ligne = $contenu_actuel['entete_ligne'];
                    }
                }
                
                $c['contenu'] = serialize(array_merge($contenu_actuel,$contenu_nouveau));
                
                // difference : ne pas creer de fichier CSV
                // mais memoriser la conversion en HTML (SPIP) du tableau
                include_spip('formulaires/ciwidget_tableau');
                $c['cache'] = ciwidget_convertir_tableau_en_html($c['donnees'],$titre,$descriptif,$entete_colonne,$entete_ligne,0,$id_widget);
                
                sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
                
                // invalider le cache correspondant
                if (!test_espace_prive()){
                    include_spip('inc/ciwidget_invalider');
                    ciwidget_invalider_cache($id_objet,$objet,$url_objet);
                }

                //tracer
                if (defined('_DIR_PLUGIN_CITRACE')){
                    if ($citrace = charger_fonction('citrace', 'inc')) {
                        $message = '('.$titre.') dans '.$objet.' '.$id_objet;				
                        $citrace('widget', $id_widget, 'import auto de donnees du widget de type '.$type_widget, $message);
                    }
                }
            }
        }
    }
    
    return $return;
}

function ciwidget_lire_xlsx($path='',$texte='',$propre=true){
    $donnees = '';
    
    include_spip('lib/simplexlsx/SimpleXLSX');

    if ($path){
        $xlsx = SimpleXLSX::parse($path);
    } elseif ($texte){
        $xlsx = SimpleXLSX::parse($texte,true);
    } else {
        $xlsx = null;
    }
    
    if ($propre){
        if ($xlsx) {
            foreach ($xlsx->rows() AS $row) {
                $donnees .= "[";
                foreach ($row AS $elt) {
                    $donnees .= '"' . ciwidget_propre_csv($elt) . '",';
                }
                $donnees .= "],";
            }
        } else {
            $erreur = SimpleXLSX::parseError();
        }

        if ($donnees){
            $donnees .= "]";
            $donnees = "[".str_replace(",]","]",$donnees);
        }
    } else {
        if ($xlsx) {
            $donnees = json_encode(array_values($xlsx->rows()),JSON_UNESCAPED_UNICODE);        
        }
    }
    
    return $donnees;
}

function ciwidget_lire_csv_brut($path=''){
    $csv = '';
    $texte='';
        
    include_spip('inc/csv');
    include_spip('inc/charsets');

    if ($path){
        $handle = fopen($path, "r");
        $texte = fread($handle, filesize($path));
        fclose($handle);
    }
    
    if ($texte){
        $charset_source = 'iso-8859-1';
        if (is_utf8($texte)) {
                $charset_source = 'utf-8';
        }
        $texte = importer_charset($texte, $charset_source);

        // Un test montre que la fonction analyse_csv de SPIP genere, avec un gros fichier,
        // le message d'erreur : Memory error, increase pcre.backtrack_limit in php.ini
        // Dans le test, il a été nécessaire de passer pcre.backtrack_limit à 2500000
        
        list($entete, $csv) = analyse_csv($texte);
        
        // enlever les scories produites par la fonction de SPIP analyse_csv
        if ($csv AND is_array($csv)){
            $csv_safe = array();
            foreach ($csv AS $row) {
                $csv_row_safe = array();
                foreach ($row AS $elt) {
                    $csv_row_safe[] = ciwidget_propre_vide($elt);
                }
                $csv_safe[] = $csv_row_safe;
            }
            $csv = $csv_safe;
        }
    }
    return $csv;
}

function ciwidget_lire_csv($path='',$texte='',$propre=true,$propre_vide=false){
    $donnees = '';

    include_spip('inc/csv');
    include_spip('inc/charsets');

    if ($path){
        $handle = fopen($path, "r");
        $texte = fread($handle, filesize($path));
        fclose($handle);
    }
    
    if ($texte){
        $charset_source = 'iso-8859-1';
        if (is_utf8($texte)) {
                $charset_source = 'utf-8';
        }
        $texte = importer_charset($texte, $charset_source);

        // Un test montre que la fonction analyse_csv de SPIP genere, avec un gros fichier,
        // le message d'erreur : Memory error, increase pcre.backtrack_limit in php.ini
        // Dans le test, il a été nécessaire de passer pcre.backtrack_limit à 2500000
        
        list($entete, $csv) = analyse_csv($texte);

        // enlever les scories produites par la fonction de SPIP analyse_csv
        if ($propre_vide){
            $entete_safe = array();
            if ($entete AND is_array($entete)){
                foreach ($entete AS $elt) {
                    $entete_safe[] = ciwidget_propre_vide($elt);
                }
                $entete = $entete_safe;
            }
            if ($csv AND is_array($csv)){
                $csv_safe = array();
                foreach ($csv AS $row) {
                    $csv_row_safe = array();
                    foreach ($row AS $elt) {
                        $csv_row_safe[] = ciwidget_propre_vide($elt);
                    }
                    $csv_safe[] = $csv_row_safe;
                }
                $csv = $csv_safe;
            }
        }
        
        if ($propre){
            if ($entete AND is_array($entete)){
                $donnees .= "[";
                foreach ($entete AS $elt) {
                    $donnees .= '"' . ciwidget_propre_csv($elt) . '",';
                }
                $donnees .= "],";
            }

            if ($csv AND is_array($csv)){
                foreach ($csv AS $row) {
                    $donnees .= "[";
                    foreach ($row AS $elt) {
                        $donnees .= '"' . ciwidget_propre_csv($elt) . '",';
                    }
                    $donnees .= "],";
                }
            }

            if ($donnees){
                $donnees .= "]";
                $donnees = "[".str_replace(",]","]",$donnees);
            }
        } else {
            $donnees = json_encode(array_values(array_merge(array($entete),$csv)),JSON_UNESCAPED_UNICODE);        
        }
    }
    return $donnees;
}

function ciwidget_propre_vide($t){
    // enlever les scories produites par la fonction de SPIP analyse_csv
    if ($t) {
        if ($t == '"'){
            $t = '';
        } elseif ($t == "&#34#"){
            $t = '';
        }
        $t = str_replace("&#44;",",",$t);
    }
    
    return $t;
}

function ciwidget_propre_csv($t){
    $safe = '';
    
    if ($t) {
        // enlever les scories produites par la fonction de SPIP analyse_csv
        $t = ciwidget_propre_vide($t);
        
        // remplacer les virgules par des points
        $t = str_replace(",",".",$t);

        // remplacer les double quote par des quote
        $t = str_replace('"',"'",$t);
        
        if (ctype_alnum(str_replace('.','',$t))) {
            $safe = $t;
        } else {
            // supprimer les accents
            include_spip('inc/charsets');
            $tsa = translitteration($t);

            // limiter aux a-zA-Z0-9, aux espaces, underscores, quote, tirets, points, deux points, slash, arobase
            $tableau = array(" ","_","'",'-','.',':','/','@',"(",")");
            $tscs = str_replace($tableau,'',$tsa);		

            if (ctype_alnum($tscs)){
                $safe = $t;
            } else {    
                // enlever les caracteres non autorises
                $longueur = strlen($tsa);
                for ($i = 0; $i < $longueur; $i++){
                    if (ctype_alnum($tsa[$i]) OR in_array($tsa[$i], $tableau))
                            $safe .= $tsa[$i];
                    else
                            $safe .= ' ';
                }
            }
        }
    }
    
    return $safe;
}

function ciwidget_extension_tableau_distant($url,$liste_extensions){
    static $tableau_extension = array();
    $extension = '';
    $extension_ok = false;

    if ($url){
        if (isset($tableau_extension[$url])){
            $extension = $tableau_extension[$url];
        } else {
            include_spip('inc/documents');
            include_spip('inc/renseigner_document');
            include_spip('inc/distant');
            $infos = renseigner_source_distante($url);

            // Pour les csv et xlsx distants, la fonction de SPIP renseigner_source_distante 
            // trouve l’extension grace au type mime qui est dans le header
            if (isset($infos['extension'])){
                $extension = $infos['extension'];
                if (in_array(strtolower($extension),$liste_extensions) ){
                    $extension_ok = true;
                }
            }

            // cas d'un type mime comme application/csv
            // qui n'est pas reconnu par SPIP (alors qu'il reconnait text/csv)
            if (!$extension_ok){
                $mime_type = '';
                if (isset($infos['mime_type'])){
                    $mime_type = $infos['mime_type'];
                }
                // pour SPIP 4.1
                if (!$mime_type){
                    $reponse = recuperer_url($url);
                    if (isset($reponse['headers'])){
                        $headers = $reponse['headers'];
                        if (preg_match(",\nContent-Type: *([^[:space:];]*),i", "\n$headers", $regs)) {
                                $mime_type = (trim($regs[1]));
                        }
                    }
                }
                if ($mime_type){
                    $tableau_mime = explode('/',$mime_type);
                    if (isset($tableau_mime[1]) AND ctype_alnum($tableau_mime[1])){
                        if (in_array(strtolower($tableau_mime[1]),$liste_extensions) ){
                            $extension = $tableau_mime[1];
                        }
                    }
                }
            } 
            
            
            $tableau_extension[$url] = $extension;
        }
    }
                
    return $extension;
}

function ciwidget_echapper_tags($texte) {
    if (empty($texte)){
        return '';
    }
    
    return str_replace(array("<",">"), array("&lt;","&gt;"), $texte);
}


function ciwidget_importer_widget($id_widget,$type_widget,$url_objet=''){
    $return = '';
    $tmp = false;
    $forcer = false;

    if (in_array($type_widget,array('graphique','tableau')) AND intval($id_widget)>0){
        if ($type_widget=='graphique'){
            $return = ciwidget_graphique_importer($id_widget,$tmp,$forcer,$url_objet);
        } elseif ($type_widget=='tableau'){
            $return = ciwidget_tableau_importer($id_widget,$tmp,$forcer,$url_objet);
        }
    }

    return $return;
}

function ciwidget_importer_cron($id_widget,$type_widget){
    $return = '';
    
    if (in_array($type_widget,array('graphique','tableau')) AND intval($id_widget)>0){
        if (test_espace_prive()){
            ciwidget_importer_widget($id_widget,$type_widget);
        } else {
            $url_cron = generer_url_action('ciwidget_importer', 'type_widget='.$type_widget.'&id_widget='.intval($id_widget).'&url='.$GLOBALS['REQUEST_URI'], true, true);
            $return = "<script>setTimeout(function(){var xo = new XMLHttpRequest();xo.open('GET', '$url_cron', true);xo.send('');},100);</script>";
        }
    }
    
    return $return;
}

?>